c     Rayini.F  begins                      ---------------------------|

c      Ini                                  ---------------------------|
c                                                                      |
c                                                                      |
 
      SUBROUTINE RayIni(RayIniErr)
#include "Implic.inc"
#include "tscunits.inc"
      EXTERNAL plasma2d, eps, zplrcnr, ftion, prtout
c
c G77 Info explains:
c    The GNU Fortran language disallows `REAL(EXPR)' and `AIMAG(EXPR)',
c where EXPR is any `COMPLEX' type other than `COMPLEX(KIND=1)', except
c when they are used in the following way:
c 
c      REAL(REAL(EXPR))
c      REAL(AIMAG(EXPR))
c 
c The above forms explicitly specify that the desired effect is to
c convert the real or imaginary part of EXPR, which might be some `REAL'
c type other than `REAL(KIND=1)', to type `REAL(KIND=1)', and have that
c serve as the value of the expression.
c 
c    The GNU Fortran language offers clearly named intrinsics to extract
c the real and imaginary parts of a complex entity without any conversion:
c 
c      REALPART(EXPR)
c      IMAGPART(EXPR)
c 
c    To express the above using typical extended FORTRAN 77, use the
c following constructs (when EXPR is `COMPLEX(KIND=2)'):
c 
c      DBLE(EXPR)
c      DIMAG(EXPR)
c
c Ugly Complex Part Extraction
c ----------------------------
c 
c    The `-fugly-complex' option enables use of the `REAL()' and `AIMAG()'
c intrinsics with arguments that are `COMPLEX' types other than
c `COMPLEX(KIND=1)'.
c 
c    With `-ff90' in effect, these intrinsics return the unconverted real
c and imaginary parts (respectively) of their argument.
c 
c    With `-fno-f90' in effect, these intrinsics convert the real and
c imaginary parts to `REAL(KIND=1)', and return the result of that
c conversion.
c 
c    Due to this ambiguity, the GNU Fortran language defines these
c constructs as invalid, except in the specific case where they are
c entirely and solely passed as an argument to an invocation of the
c `REAL()' intrinsic.  For example,
c 
c      REAL(REAL(Z))
c 
c is permitted even when `Z' is `COMPLEX(KIND=2)' and `-fno-ugly-complex'
c is in effect, because the meaning is clear.
c 
c    `g77' enforces this restriction, unless `-fugly-complex' is
c specified, in which case the appropriate interpretation is chosen and
c no diagnostic is issued.
c G77 Info explains, ends.
c
c     Integration is in coords  R     Z     Phi
c     Starting uses             Rad   Pol   Phi (no B in Rad direction)
c
c     Kr       1   **  Bz  Br  **  ** Krad **
c         =  ----  *            *  *        *
c     Kz     Bpol  ** -Br  Bz  **  ** Kpol **
c
c     Kpar = (KtorBtor + KpolBpol)/B
c     Krad2 = Kperp2 - (KpolBtor - KtorBpol)**2/B**2
c     Krad is positive for slow wave, negative for fast.
c     Bpol has the sign of (Bz(R-Rmaj) - BrZ) in order to keep the
c     sign of Kr, Kz, Krad straight.  This should work except in
c     quite pathological shapes.
c
c     NAG routine needs the aNAGco(4), ReZ(3), ImZ(3), Toleran,
c     and integers nNAG, Ifail
c     REAL
c    ^        aNAGco(4), ReZ(3), ImZ(3), toleran
c     INTEGER          nNAG     , ifail
c     REAL
c    ^        x02aaf
      REAL
     ^        Kpar2, Kpol, Krad, Ktor
      COMPLEX zc(3)     
      REAL    Azplr(4)
#include "params.inc"
#include "Doflags.inc"
#include "PlPr.inc"
#include "dielec.inc"
#include "RayBins.inc"
#include "RayWrk.inc"
#include "ProfBody.inc"
      REAL
     ^     r,z, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael
      INTEGER i, DummyEr, RayIniErr
      REAL
     ^        Bpol,Bpol2,Btot2,
     ^        DispRela,
     ^        det,fast,plas,Qpar,Sig,slow,try,
     ^        zi1,zi2,zi3,zr1,zr2,zr3, AprxSlow, AprxFast, discrimt
      REAL
     ^        CosT,drad,rad,rstar,SinT,t, SEARCHINCR
      SEARCHINCR = 0.005
      T = THET0 * 6.28318
      RayIniErr = 0
                            Rad = Rmax - Rmaj
      If ( Cos(T) .lt. 0. ) Rad = Rmaj - Rmin
      CosT = Abs(Cos(T)) + 1.0E-20
      SinT = Abs(Sin(T)) + 1.0E-20
      Rad  = amin1 ( Rad/CosT , Zmax/SinT )
      rstar= -SEARCHINCR
      drad = abs(rstar)
 
5     do 30 I=1,10000
      Rad = Rad - drad
      r    = Rmaj + Rad*Cos(T)
      z    =        Rad*Sin(T)
      Kpol = enpol*2.0*3.1416*(fghz/0.3)
      Ktor = enpar*2.0*3.1416*(fghz/0.3)
      if (enpar .eq. 0.00) then
        RayIniErr = 2
        call LSCwarn(' enpar == 0 in RayIni ')
        return
      endif
      call     plasma2d(r,z, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)
 
      If ( pe2 .le. pe2min ) Go To 30
c
      Bpol2= Br*Br + Bz*Bz
      Btot2= Bpol2 + (RBphi/r)**2
      Bpol = sqrt(Bpol2)
      Sig  = (r - Rmaj)*Bz - z*Br
      If ( Sig .lt. 0. ) Bpol = -Bpol
      Kpar2 = ( Kpol*Bpol + Ktor*RBphi/R )**2/Btot2
      call Eps ( r, z, Kpar2, 0.0000 )
 
10    Azplr(4) = -(aio/fghz**4 + ael)
      Azplr(3) =  Eper
      Qpar = Kpar2 - woc2*Eper
      Azplr(2) = Qpar*(Epar+Eper) +  woc2*Exy**2
      Azplr(1) = Epar*( Qpar**2 - woc4*Exy**2 )
c
c     -                                 Estimate the roots far from lmc
      discrimt   =  Azplr(2)**2 - 4. * Azplr(3) * Azplr(1)
      if ( discrimt .le. 0. ) then 
        discrimt = 0.
        RayIniErr= 1
        call LSCwarn(' no accessibity found for this ray ')
        return
      endif
c
      call ZPLRCnr(3,Azplr,ZC)
c     Finds Zeroes of a Polynomial with Laguerre's method if
c     Real Coefficients
c     using Numerical Recipes code so we dont depend on IMSL
      zr1 = real (zc(1))
      zr2 = real (zc(2))
      zr3 = real (zc(3))
      zi1 = aimag(zc(1))
      zi2 = aimag(zc(2))
      zi3 = aimag(zc(3))
      if (PrFlg(RAYWR) .ge. TRUE) then
       AprxSlow = ( - Azplr(2) + sqrt(discrimt)) / (2. * Azplr(3))
       AprxFast = ( - Azplr(2) - sqrt(discrimt)) / (2. * Azplr(3))
       write(nLSCcom2,'('' Aprox Fast, Slow: '', 2(1x,1pe10.3),/,
     ^                  '' Roots found:      '', 3(1x,1pe10.3)   )')
     ^ AprxFast, AprxSlow, zr1, zr2, zr3
       if (AprxSlow .gt. 0.0 ) then
          write(nLSCcom2,'('' '',/)')
       endif
      endif

ccccccccccccccccccccccccccc
c     aNAGco(1)= Azplr(4)
c     aNAGco(2)= Azplr(3)
c     aNAGco(3)= Azplr(2)
c     aNAGco(4)= Azplr(1)
c     nNAG     = 4
c     toleran  = x02aaf(0.1)
c     call c02aef ( aNAGco, nNAG, ReZ, ImZ, toleran, ifail )
c     zr1      = ReZ(1)
c     zr2      = ReZ(2)
c     zr3      = ReZ(3)
c     zi1      = ImZ(1)
c     zi2      = ImZ(2)
c     zi3      = ImZ(3)
ccccccccccccccccccccccccccc

c     The normal case is that all roots are real, and we see if we can start.
22    continue
      plas = amax1(zr1,zr2,zr3)
      fast = amin1(zr1,zr2,zr3)
      slow = -1.0e+30
      if (zr1.lt.plas .and. zr1.gt.fast) slow = zr1
      if (zr2.lt.plas .and. zr2.gt.fast) slow = zr2
      if (zr3.lt.plas .and. zr3.gt.fast) slow = zr3
      if (slow .eq. -1.0e+30) go to 30
      if (lfast .eq. 1) try = fast
      if (lfast .eq. 0) try = slow
24    if (try .lt. 0. ) go to 30
      try = try - ( Kpol*RBphi/R - Ktor*Bpol )**2/Btot2
      if ( try .lt. 0. ) go to 30
      try  = +sqrt(try)
 
                       krad = + try
      if(lfast .eq. 1) krad = - try
 
      go to 35
30    continue
      if (PrFlg(RAYWR) .ge. TRUE ) write(nLSCcom2,600) 
     ^                                       zr1,zr2,zr3,fast,slow,plas
      RayIniErr =2
      call LSCwarn(' cant find a starting point for this ray')
      return
35    continue
      y(1)  =  r
      y(2)  =  z
      y(3)  =  0.
      y(4)  =  ( Krad*Bz + Kpol*Br ) / Bpol
      y(5)  =  (-Krad*Br + Kpol*Bz ) / Bpol
      y(6)  =    Ktor*r
      y(7)  =  0.
c     to begin the time as fn of distance
      y(8) = begin
      det = DispRela(y(1),y(2),    y(4),y(5),y(6))
c
      if (PrFlg(RAYWR) .ge. TRUE ) then
        write(nLSCcomm,602)r,z,psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael
        write(nLSCcomm,601)y(1),y(2),y(3),y(4),y(5),y(6),y(7),
     ^        det,d1,d2,d4,fast,slow,plas
      endif
c
70    call ftion(DummyEr)
c     only to initialize dkper & wdddw for damping calculation
      call prtout(0)
c
600   format (' error in ini',/,' roots are ',3e10.3,/,
     ^        ' fast,slow,plas are',3e10.3     )
601   format ( ' y is ',/,1x,1p7e10.2,/,' d(y) is ', 1pe10.2,/,
     ^         ' D elements are:', 1p3e10.2,/,
     ^         ' fast,slow,plas are' ,1p3e10.2)
602   format ( ' ',/,' New ray',/,
     ^         '    r    z    psi     Br     Bz  RBphi',
     ^         '    omc    Tee   pe2     pi2   aio     ael',/,
     ^              2(f5.2),6(f7.3),f7.0,3(f7.3))
c
      return
      END
c                                                                      |
c                                                                      |
c     ini ends                              ---------------------------|

c     zplrcnr begins    ------------------------------------------------
c                                                                      |
c                                                                      |
      SUBROUTINE zplrcnr (degree, coefr, zeroc)
#include "Implic.inc"
      EXTERNAL zrootsnr 
c     ZPLRCNR:
c     finds Zeros of Polynomials with Laguerre's method assuming
c     Real Coefficients by calling a routine from
c     Numerical Recipes.
c     The calling convention is set up to look like IMSL call ZPLRC.
c     f(x) = 0 = coefr(1) + coefr(2)*x + coefr(3)*x**2 ...etc
      INTEGER degree, DEGMAX, i, polish
      PARAMETER (DEGMAX=10)
      REAL    coefr(degree+1)
      COMPLEX coefc(DEGMAX+1), zeroc(degree)
c
c     if (degree .gt. DEGMAX ) HALT ' out of bounds in ZPLRCNR '
c
c                                       zroots needs complex coef's
      do 10 i = 1, degree+1
      coefc(i) = cmplx ( coefr(i) , 0. )
  10  continue
c
      polish = 1
      call zrootsnr ( coefc, degree, zeroc, polish )
c
      return
      END
c
c     ------------------------------------------------------------------
c
      SUBROUTINE laguernr ( coef, degree, x, epsilon, polish )
#include "Implic.inc"
c     Given the  DEGREE  and  DEGREE+1  complex COEF's of the polynomial
c     Sum COEF(i) X**(i-1) and given  epsilon the desired fractional
c     accuracy, and given a complex value  X , this routine improves  X
c     by Laguerre's method until it converges to a root of the given
c     polynomial.  For normal use  POLISH  should be input as 0 (false).
c     When  POLISH  is 1 (true) the routine ignores  EPSILON  and
c     instead attempts to improve  X  (assumed to be a good initial
c     guess) to the achievable roundoff limit.
c     Ref: Numerical Recipes in Fortran, page 264.
c
      INTEGER degree, iter, MAXIT, j, polish
      REAL    
     ^        epsilon, EPSS, err, abx, cdx
c     REAL    dxold                     ! Given in book; not used
      COMPLEX 
     ^        coef(degree+1), x, dx, x1,b,d,f,g,h,sq,gp,gm,g2, ZERO
      PARAMETER (ZERO=(0.,0.), EPSS=6.e-07, MAXIT=100)
c
c     dxold = cabs ( x )                ! Gven in book; not used
c                                       Loop over iterations up to
c                                       allowed maximum
      do 12 iter = 1, MAXIT
        b   = coef ( degree+1 )
        err = cabs ( b )
        d   = ZERO
        f   = ZERO
        abx = cabs ( x )
c                                       Efficient computation of the
c                                       polynomial and its first 2
c                                       derivatives
        do 11 j = degree, 1, -1
            f   = x*f + d
            d   = x*d + b
            b   = x*b + coef ( j )
            err = cabs ( b ) + abx * err
  11    continue
c                                       Estimate of roundoff error in
c                                       evaluating polynomial
        err = EPSS * err
        if ( cabs ( b ) .le. err ) then
            return
c                                       The generic case: use Laguerre's
c                                       formula
        else
            g  = d / b
            g2 = g * g
            h  = g2 - 2. * f / b
            sq = csqrt ( (degree-1) * (degree*h - g2) )
            gp = g + sq
            gm = g - sq
            if ( cabs (gp) .lt. cabs (gm) ) gp = gm
            dx = degree / gp
        endif
        x1    = x - dx
        if ( x .eq. x1 ) return
        x     = x1
        cdx   = cabs ( dx )
c       dxold = cdx                     ! Given in book; not used
        if ( polish .eq. 0 ) then
            if ( cdx .le. epsilon*cabs ( x ) ) return
        endif
 
  12  continue
      call LSCstop( ' too many iterations in LAGUER root finder ')
      return
      END
c
c     ------------------------------------------------------------------
c
      SUBROUTINE zrootsnr ( coef, degree, roots, polish )
#include "Implic.inc"
      EXTERNAL laguernr 
c     Given the DEGREE and the  DEGREE+1  complex COEF's of the polynomial
c     Sum COEF(i) x**(i-1) this routine successively calls LAGUER and
c     finds all DEGREE complex ROOTS.  The integer variable POLISH
c     should be input as 1 (true) if polishing is desired, of 0 (false)
c     if the roots will be subsequently polished by other means.
c     Ref: Numerical Recipes in Fortran, page 265.
c
c

      INTEGER degree, MAXDEGRE, i, j, jj, polish
      REAL    
     ^        EPSILON
      PARAMETER (EPSILON=1.e-06, MAXDEGRE=101)
      COMPLEX 
     ^        coef(degree+1), x, b, c, roots(degree), defl(MAXDEGRE)
c
c                                       Copy coef's for successive deflation
      do 11 j = 1, degree+1
        defl(j) = coef(j)
  11  continue
c
      do 13 j = degree, 1, -1
c                                       Start at 0 to favor smallest
c                                       remaining root
        x = cmplx ( 0., 0. )
        call laguernr ( defl, j, x, EPSILON, 0 )
        if ( abs( aimag(x) ) .le. 2.*EPSILON**2*abs( real(x) ) )
     ^      x = cmplx ( real(x) , 0. )
        roots( j ) = x
        b = defl( j+1 )
c                                       Forward deflation
        do 12 jj = j, 1, -1
            c = defl(jj)
            defl(jj) = b
            b = x*b + c
  12    continue
  13  continue
c
      if ( polish .eq. 1 ) then
c                                       Polish roots using undeflated coefs
        do 14 j = 1, degree
            call laguernr ( coef, degree, roots(j), EPSILON, 1 )
  14    continue
c
      endif
c
c                                       Sort roots by real part by
c                                       straight insertion
      do 16 j = 2, degree
        x = roots (j)
        do 15 i = j-1, 1, -1
            if ( real( roots(i) ) .le. real( x ) ) go to 10
            roots ( i+1 ) = roots ( i)
  15    continue
        i=0
  10    roots ( i+1 ) = x
  16  continue
      return
      END
c                                                                      |
c                                                                      |
c     zplrcnr ends      ------------------------------------------------

c     spectrum                              ---------------------------|
c                                                                      |
c                                                                      |
c      REAL FUNCTION spectrum (ParIdx)
c#include "Implic.inc"
c#include "params.inc"
c#include "RayWrk.inc"
c      REAL
c     ^        ParIdx, a, c
c      INTEGER istart
cc     ParIdx    Parallel refractive index, n_\parallel
cc     a         width parameter
cc     c         normalization constant
cc     istart    0 on loading, 1 after first call
cc     spectrum  function based on f(x) = c * 1/(x^2 + a^2)
cc               where c= a/PI if the range were +/- infinity
c 
c      DATA      istart/0/
c 
c      if (istart .eq. 0 ) then
c        istart = 1
c        a = spwidth/2.
c        c = a/( atan((nparmax-spcentr)/a)
c     ^        - atan((nparmin-spcentr)/a) )
c      endif
c 
c      spectrum = c/( (ParIdx-spcentr)**2 + a*a )
c      return
c 
c      END
cc                                                                      |
cc                                                                      |
cc     spectrum ends                         ---------------------------|
c
c     Rayini.F  ends                           ------------------------|
