c     Raystore.F                        -------------------------------|
c                                                                      |
c                                                                      |
c
C     PrtOut                                ---------------------------|
C                                                                      |
C                                                                      |
      SUBROUTINE PrtOut(iprint)
#include "Implic.inc"
            EXTERNAL plasma2d, DispRela, E2byPr
      INTEGER icount, iprint
      REAL    NperFs, NperSl
c     If iprint = 0, print only if the count is reached
c                 1, print at this point regardless of the count
#include "PIetc.inc"
#include "tscunits.inc"
#include "params.inc"
#include "Doflags.inc"
#include "PlPr.inc"
#include "dielec.inc"
#include "RayBins.inc"
#include "RayWrk.inc"
c                                       If starting a new ray, set
c                                       the print counter for headings
c                                       icount
c                                       to 0.
      if ( lnewray .gt. 0 ) icount = 0
 
        call E2byPr
 
      mstpLH = mstpLH + 1
      if ( iprint .eq. 1 ) go to 15
      if ( mstpLH .lt. nfreq ) return
      mstpLH = 0
 
15    continue
      iplt = iplt + 1
      if ( iplt .gt.IDM ) iplt = IDM
      yrr(iplt)   = y(1)
      yzz(iplt)   = y(2)
      ypp(iplt)   = y(3)
      yps(iplt)   = rtPsRy(izone)
      ypr(iplt)   = NperRy(izone)
      ypl(iplt)   = npar  (izone,iray)
      yed(iplt)   = power (izone,iray)
 
      if ( mod(icount,10) .eq. 0 .and. PrFlg(RAYWR) .ge. TRUE ) then
            write(nLSCcomm, 610) iray
      endif
      icount = icount + 1
c
c
      if (PrFlg(RAYWR) .ge. TRUE )
     ^                    write (nLSCcomm, 611)
     ^ izone,izind(izone,iray), yps(iplt),
     ^ npar(izone,iray), NperRy(izone),
     ^ ezsq(izone,iray), 
     ^ dtdV, DetrRy(izone), DistRy(izone)

cizone izind  rpsi  npar  nper     Ez2    Err2    Ert2    dtdV     det path ln
c  199   101 +0.99 -10.1 +100. +6.e-09 -1.e-00 -1.e-00 +1.e-00 -1.e-05  26.001

cizone izind  rpsi  npar  nper     Ez2    dtdV     det path ln
c  199   101 +0.99 -10.1 +100. +6.e-09 +1.e-00 -1.e-05  26.001


 610  format     (' ray',i2,/,
     ^' izone izind  rpsi  npar  nper',
     ^'     Ez2    dtdV     det path ln' )

 611  format     (
     ^1x,i5,
     ^1x,i5,
     ^1x,f5.2,
     ^1x,f5.1,
     ^1x,f5.0,
     ^1x,1pe7.0,
     ^1x,1pe7.0,
     ^1x,1pe7.0,
     ^   0pf8.3   )

c     diagnostic prints
c
cizone izind        epsZ        epsL      NperRy      NperFs    NperSl     dtdV
c  199   101 +1.2345e-05 +1.2345e-12 +1.2345e-12 +1.2345e-11 +1.23e-11 1.23e-00
 1311 format( 1x,i5,i5,5(1pe11.4,1x),e10.2)
 1312 format('^',i5,i5,5(1pe11.4,1x),e10.2)
 1310 format(' ray',i2,/,
     ^' izone izind      epsZ        epsL      NperRy',
     ^'      NperFs      NperSl       dtdV'  )
      return
      END
C                                                                      |
C                                                                      |
C     PrtOut                                ---------------------------|
 
 
C     E2byPr                                ---------------------------|
C                                                                      |
C                                                                      |
      SUBROUTINE E2byPr
#include "Implic.inc"
      EXTERNAL DispRela, plasma2d, ivtabl
      INTEGER  ivtabl
#include "tscunits.inc"
#include "params.inc"
#include "PIetc.inc"
#include "MKSetc.inc"
#include "dielec.inc"
#include "Doflags.inc"
#include "ProfBody.inc"
#include "FeBins.inc"
#include "RayBins.inc"
#include "RayWrk.inc"
#include "TSCgrap.inc"
#include "PlPr.inc"
c     E2byPr    Finds for all zones the ratio E_{z}^2/P;
c     damping constants  dlnPdsX  dlnPdsK;
c     n_{\parallel}; and polarization.
c     Written by D. W. Ignat, April 1991.
c     The time and path-position of entering and leaving
c     a zone is obtained by linear interpolation.  This is to allow
c     for best accuracy in obtaining  dt  and  ds .
c     This version does not anticipate crossing more than one zone
c     boundary in a step, but if this happens a warning is issued.
c     
c     The approach is to average the quantity needed for each zone by
c     accumulating a total and dividing by the number of entries.  This
c     alone is sufficient for n_{\parallel} and polarization.
c     For E_z^2/P ... ezsq ... one needs to multiply by the time spent
c     in the zone, and divide by the volume of the zone.
c     For dlnPdsK  dlnPdsX we have chosen to multiply by   ds  at the end.
c     These variables are really, then,
c     dP/P -- Kernel to accept df/dv later; and dP/P -- assuming MaXwellian.
c
c     Zone boundaries are between the psi points, as follows.
c
c     +     .     +     .     +     .     +     .     +     .     +
c psimin                                                        psimax
c     1           2           3                     npsi-1        npsi
c  zone 1---><--zone 2--><--zone 3-->                        <--zone npsi
c
c     Ray power at the beginning is indexed 1.  As ray crosses into
c     the next zone, the value is indexed 2.  Power deposited in outer most
c     zone is therefore P_1 - P_2
c
c     sNew, sOld                New and old path length from start
c     tNew, tOld                and time duration from start.
c     RzindNew, RzindOld        The real and integer values of the zone
c     IzindNew, IzindOld        index.  These are related to the izind array.
c                               zind is small at the center and large at edge.
c                               izone=1 implies edge value of zind for
c                               the start of the ray.
c     Rzind* = (Psi - PsiMinx) / (PsiMaxx - PsiMinx) * (Npsi - 1) + 1.5
c     Rzind* = (Psi - PsiMinx) /  DelPsi                          + 1.5
c     Izind* = ifix(Rzind*)
c
c          Rzind*
c            ^
c     npsi   +
c            |    .                                  .
c     npsi-1 +
c            |         .    double jump              \
c     npsi-2 +            /                            double jump
c            |                                  .
c     .      + 
c            |              .              .
c     .      +
c            |                   .    .
c     .      +
c            |
c     4      +
c   izind=3  |
c     3      +
c   izind=2  |
c     2      .____.____.____.____.____.____.____.____.____.
c                 0    1    2    3    4    5    6    7    8 > s (or) t
c
c
c     sSlope, tSlope    (New - Old)/(RzindNew - RzindOld)
c     sLeave(nzones), sEnter(nzones) are redundant: sLeave(i)=sEnter(i+1)
c     tLeave(nzones), tEnter(nzones) are redundant: tLeave(i)=tEnter(i+1)
c     accum(nRayQt)  an accumulator for averaging
c                    when the zone number is constant
c     RayQt(nRayQt)  the fresh parameter to be averaged
c     NinAc(nRayQt)  the number of entries now in the accumulator
c
c     RayQts are:
c     1 for ezsq    (epsz)^{-1} * 2.
c old 2 for dlnPdsK dD/dK33 /abs(dD/dk) * Im K33
c old 3 fzor dlnPdsX but the _K means kernel for adding df/dv later
c old               and the _X means MaXwellian assumed.
c     2 for dlnPdsK dD/dK33 /(w/2)(dD/dw) / (dV/dwt)f * Im K33
c     3 for dlnPdsX but the _K means kernel for adding df/dv later
c                   and the _X means MaXwellian assumed.
c     4 npar
c     5 epolX
c     6 epolY
c
c     CLIGHT    speed of light, in 10^8 m/s
c     ee        electron epsilon == 1 + \omega_{pe}^2/\omega^2
c     eps0      (\mu_o c^2)^{-1} farads per meter; epsilon sub zero
c     epsz      epsilon sub z; converts E_z^2 to energy density
c     ex        E_x / E_z ; x-polarization
c     ey      i E_y / E_z ; y-polarization
c     PI        3.1415926
c     cEparIK   constant converts df_e/dv to Im{K_{33}}
c               ImEpar == - PI \omega_{pe}^2/k_{\parallel}^2 df/dv
c                      == - cEparIK df/dv / kpar2
c
c
c     [ K + n n - n^2 I ]  \cdot E = 0
c       =   - -       =          -
c
c     so if E = [ ex , i ey , 1 ] E_z , then
c     ex = - (Kzz - nperp^2)/(nperp npar)
c     ey = ex Kxy / (Kyy - n^2)
c
c
c     (1/P) (dP/dt) = - 2 Im(K_par) dD/dK_par / (dD/d\omega)
c     (1/P) (dP/ds) = - 2 Im(K_par) dD/dK_par / abs(dD/dk)
c           (dP/dV) = - 2 Im(K_par) dD/dK_par / (dD/d\omega) \times
c                         (eps_z  /2) E_z^2
c
c     P =  U  \vec{v_g} \cdot \vec{A} where A is area of ray
c     P = <U>  (dV/dt)  on flux surface average
c
c     U = (1/2) (eps_0 /2) E^* \cdot [K + d/d\omega(\omega K)] \cdot E
c                          -          =                    =         -
c          ^        ^                 ^           ^
c          |                      magnetic     electric and particle
c      avg amplitudes
c
c       = (E_z^2/2) (eps_0 /2) [ ex, -i ey, 1] \cdot
c   -                      -
c   |  2 ee    i Kxy    0  |   ex
c   | -i Kxy   2 ee     0  | i ey
c   |    0       0      2  |   1
c   -                      -
c
c     where   ee = (1 + \omega_{pe}^2 / \omega_{ce}^2)
c
c     U = E_z^2  (eps_0 /2) [ 1 + ee (ex^2 + ey^2) - Kxy ex ey ]
c       = E_z^2  (eps_z /2)
c
c     E_z^2 /P  = [(eps_z /2) dV/dt]^{-1}        == ezsq
c     (note that dt is normalized with \omega....to get MKS put back.)
c
c     dVol(NPSIDIM) is an array such that dVol(j) is the volume
c     centered on psi_j, etc.  This is used in calculating
c     dV/dt.  Once a ray enters a zone, it is assumed to be spread out
c     over all the volume of that zone.
c
c     Manifestly evident consistency with the QL form is consistent
c     with
c     U = E_z^2 (eps_L /2)
c     where
c                eps_L/eps0 = \omega/2 dD/d\omega / (dD/dEpar)
c
c
c     For some special studies, the components along field,
c     perp to field and along gradient, perp to field and along
c     flux surface are important.  Call the unit vectors \
c     e_11, e_rr, e_tt respectively.
c     Related unit vectors are toroidal, along gradient, poloidal,
c     e_ph, e_rr, e_pl
c
c     The code is written in unit vectors
c     e_ph, e_R , e_Z, usually referred to as 
c     (e_R , e_Z, e_ph) , (y(1), y(2), y(3)) , (y(4), y(5), y(6))
c
c     e_rr =       Bz/Bp e_R     -    Br/Bp e_Z +     0 e_ph
c     e_tt = Br/Bp Bph/B e_R  + Bz/Bp Bph/B e_Z + -Bp/B e_ph
c     e_11 =       Br /B e_R  +        Bz/B e_Z + Bph/B e_ph
c
c     e_pl =       Br/Bp e_R  +       Bz/Bp e_z +     0 e_ph
c
c     B    =  sqrt ( Br^2 + Bz^2 + Bph^2 )
c     Bp   =  sqrt ( Br^2 + Bz^2 ) 
      CHARACTER*70 ErrMsg
      INTEGER nRayQt, NinAc
      PARAMETER (nRayQt=6)
      REAL    RayQt(nRayQt), accum(nRayQt)
      INTEGER ifirst, i, jzn, jry,
     ^        IzindNew, IzindOld, IzindJmp
      REAL    
     ^        RzindNew, RzindOld, RzindCrs,
     ^        sNew    , sOld    , tNew    , tOld    ,
     ^        sSlope  ,           tSlope  ,
     ^        sEnter(NZONDIM+1) , sLeave(NZONDIM)   ,
     ^        tEnter(NZONDIM+1) , tLeave(NZONDIM)
      EQUIVALENCE (tEnter(2), tLeave(1))
      EQUIVALENCE (sEnter(2), sLeave(1))
      DATA    ifirst   /
     ^          1      /
      REAL
     ^        Btot, Bpol, Bphi,  dDdEpar, dDdEparOld,
     ^        ee, eps0, ex, ey, woc,
     ^        Kpar, Kper, Kpar2,Kper2,
     ^        psie2,qpar,veow2
      REAL
     ^        psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael
      REAL    
     ^        DispRela, det, dum
      REAL    
     ^        NparDead, NperDead, MaxwDead, MxdPdz, SMALL
      DATA    NparDead, NperDead, MaxwDead, MxdPdz, SMALL   / 
     ^            9.8 ,     147.,  1.0e-12, 0.900,  1.0e-30 /
c    ^            9.8 ,     147.,  1.0e-12, 0.001,  1.0e-30 / ! from 96
c     MxdPdz = 0.9 means the most Maxwellian Power Lost in a zone
c              is 10%....

      real    RE41, RE42
      REAL
     ^        ZERO, ONE
      DATA    ZERO, ONE/
     ^         0.0, 1.0/
c
      if (ifirst .eq. 1) then
c                                       Initialize constants; note omega fixed 
        ifirst = 0 
        cEparIK = 4. * PI * PI * ECOULB**2/ELECMS * 1.0e-08
        eps0    = 1./(4.*PI*1.0e-7*CLIGHT*CLIGHT*1.0e+16)
        omega   = fghz*2.*PI*1.0e+9
        woc     = sqrt(woc2)
      endif
c
c     Begin initializations associated with starting a new ray --------|
c                                                                      |
c                                       lnewray is a flag set in DoRay
      if (lnewray .gt. 0) then
          lnewray = 0
          call plasma2d
     ^            (y(1),y(2), psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)
          tOld   = y(7)
          sOld   = y(8)
          Bpol  = sqrt (Br*Br + Bz*Bz)
          Bphi  = RBphi/y(1)
          Btot  = sqrt ( Bpol*Bpol + Bphi*Bphi)
          Kpar  =( y(4)*Br + y(5)*Bz            + y(6)/y(1)*Bphi)/Btot
c
          Kpar2 = Kpar**2
          Kper2 = Y(4)**2 + Y(5)**2 + (Y(6)/Y(1))**2   -  Kpar2
          Kper  = sqrt ( abs(Kper2) )

          izone  = 1
c         RzindOld = (Psi - PsiMinx)/DelPsi + 1.0 zones bounded by psi--archaic
c         RzindOld = (Psi - PsiMinx)/DelPsi + 1.5 zones centerd on psi 
          RzindOld = (Psi - PsiMinx)/DelPsi + 1.5
          RE41 = RzindOld
          IzindOld = ifix(RE41)
c         IzindOld = ifix(RzindOld)

          izind(izone,iray) = IzindOld
          sEnter(izone) = sOld
          tEnter(izone) = tOld
c                                       These are not needed, but are
c                                       plotted sometimes.
c         PowrRy(izone)   = 0.          !! prior to apr93
          PowrRy(izone)   = 1.
          RofRay(izone)   = y(1)
          ZofRay(izone)   = y(2)
          PofRay(izone)   = y(3)
          NparRy(izone)   = Kpar/woc
          NperRy(izone)   = Kper/woc
          rtPsRy(izone)   = sqrt( (psi-psimin)/(psilim-psimin) )
          TimeRy(izone)   = y(7)
          DistRy(izone)   = y(8)
          NeofRy(izone)   = pe2/Pe2Fac * 1.0e+14
          BthRay(izone)   = sqrt(Br**2+Bz**2)
          BphRay(izone)   = RBphi/RofRay(izone)

          det = DispRela ( y(1) , y(2) , y(4) , y(5) , y(6)  )
          d1 = abs(d1)
          d2 = abs(d2)
          d4 = abs(d4)
          det = det / amax1( d1, d2,d4 )
          DetrRy(izone)   = det
 
c                                       The quantities to be collected
c                                       (RayQt) are averaged over the
c                                       zone by summing into accum,
c                                       dividing by NinAc.  This clears.
          do 50 i=1,nRayQt
            accum(i) = 0.
            RayQt(i) = 0.
 50       continue
          NinAc = 0
          dtdV  = 0.
          return
 
      endif
c                                                                      |
c     End   initializations associated with starting a new ray --------|
c
c                                       Find location and various parameters.
c                                       This is the NORMAL BEGINNING point, in
c                                       that all initializations have been made
c                                       and the ray is progressing through
c                                       zones.
c
      call plasma2d (y(1),y(2), psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)
      Bpol  = sqrt (Br*Br + Bz*Bz)
      Bphi  = RBphi/y(1)
      Btot  = sqrt ( Bpol*Bpol + Bphi*Bphi)
      Kpar  = ( y(4)*Br + y(5)*Bz            + y(6)/y(1)*Bphi)   / Btot
c
      Kpar2 = Kpar**2
      Kper2 = Y(4)**2 + Y(5)**2 + (Y(6)/Y(1))**2   -  Kpar2
      Kper  = sqrt ( abs(Kper2) )
      Qpar = Kpar2 - woc2*Eper
      dDdEparOld = (Qpar*(Qpar + Kper2) - woc4*Exy**2)
      dDdEpar    = (Qpar + kper2)*kpar2*kper2 / ( kper2 - woc2*Epar )

      EparI = 0.
      veow2 = 0.0445e-04*tee/fghz**2
      psie2 = 2.*veow2*kpar2
c                                       Trying to avoid overflows here.
      if ( psie2 .gt. 0.02 ) then
        psie2 = 1./psie2
        EparI = 2.*RTPI*epsq*psie2*sqrt(psie2)*exp(-psie2)
      endif
c
c     dDdEparOld = (Qpar*(Qpar + Kper2) - woc4*Exy**2)  is the term 
c     multiplying the Epar or K_{33} or K_{zz} in D.
c     This is not manifestly positive, but it is believed to be positive.
c     Now called Old.  We have had trouble with this evaluating wrong. 24apr92
c
c     Using the dispersion relation, dDdEpar can be rewritten
c     dDdEpar = (Qpar + kper2) kpar2 kper2 / ( kper2 - woc2 Epar )
c
c     dDdkABS is partial of D wrt vector k, abs value
c     The - is because of damping; the 2. is because power is field ^2
c
c     EparIK = cEparIK / Kpar2
      ex    = - (woc2*Epar - Kper2)/(Kper*Kpar)
c     ey    = ex*Exy / ( Eper- (Kper2+Kpar2)/woc2 ) equivalent to following:
      ey    =(ex*(Eper - Kpar2/woc2) + Kper*Kpar/woc2 ) / Exy
      ee    = 1. + epsq/ecyc2
      epsz  = eps0*( 1. + ee*(ex*ex+ey*ey) - Exy*ex*ey )
c     epQL  =        0.5 * wdDdw / dDdEparOld ! changed form 25Apr92
      epQL  =        0.5 * wdDdw / dDdEpar
      epsL  = eps0*  epQL
 
c     RayQt(1)            = 2./epsz
      RayQt(1)            = 2./epsL
c     RayQt(2)            = + 2.  * dDdEpar  / dDdkABS * EparIK
c     RayQt(3)            = - 2.  * dDdEpar  / dDdkABS * EparI
c     RayQt(2)            = + EparIK / epQL jul7 92
      RayQt(2)            = + 1.00   / epQL
      RayQt(3)            = - EparI  / epQL
      RayQt(4)            = Kpar/woc
      RayQt(5)            = ex
      RayQt(6)            = ey
 
      tNew   = y(7)
      sNew   = y(8)
c
      RofRay(izone)   = y(1)
      ZofRay(izone)   = y(2)
      PofRay(izone)   = y(3)
      NparRy(izone)   = Kpar/woc
      NperRy(izone)   = Kper/woc
      rtPsRy(izone)   = sqrt( (psi-psimin)/(psilim-psimin) )
      TimeRy(izone)   = y(7)
      DistRy(izone)   = y(8)
      NeofRy(izone)   = pe2/Pe2Fac * 1.0e+14
      BthRay(izone)   = Bpol
      BphRay(izone)   = Bphi
      det = DispRela ( y(1) , y(2) , y(4) , y(5) , y(6)  )
      d1 = abs(d1)
      d2 = abs(d2)
      d4 = abs(d4)
      det = det / amax1( d1, d2,d4 )
      DetrRy(izone)   = det
c
c
      RzindNew = (Psi - PsiMinx)/DelPsi + 1.5
      RE41     =  RzindNew
      IzindNew = ifix(RE41)
c     IzindNew = ifix(RzindNew)
c                                       START major IF/ELSE/ENDIF branch.
c                                       If we are in the same zone as
c                                       before, put RayQt in accumulator.
      if ( IzindNew .eq. IzindOld ) then
        do 100 i=1,nRayQt
          accum(i)=accum(i)+RayQt(i)
 100    continue
          NinAc = NinAc + 1
c                                       We are in a new zone.
c                                       Divide the accumulator by # entries
c                                       but take care if NinAc = 0.
c                                       Interpolate to find crossings.
c                                       The ELSE of the major IF/ELSE/ENDIF branch
      else
c
        do 101 i=1,nRayQt
          if (NinAc .eq. 0) then
            accum(i)=RayQt(i)
          else
            accum(i)=accum(i)/float(NinAc)
          endif
 101    continue
        NinAc = 0
 
        sSlope   = ( sNew - sOld ) / ( RzindNew - RzindOld )
        tSlope   = ( tNew - tOld ) / ( RzindNew - RzindOld )
        RE41     = RzindNew
        IzindNew = ifix(RE41)
c       IzindNew = ifix(RzindNew)
c                                       The crossing point is different
c                                       depending on whether the ray is going
c                                       outward:   IzindNew > IzindOld
c                                       or inward: IzindNew < IzindOld
            if (IzindNew .gt. IzindOld) then
                RzindCrs = float(IzindOld) + 1.
            else
                RzindCrs = float(IzindOld)
            endif
        sLeave(izone) = sOld + sSlope * (RzindCrs - RzindOld)
        tLeave(izone) = tOld + tSlope * (RzindCrs - RzindOld)
c
c                                       EQUIVALENCE accomplishes this:
c                                       sEnter(izone+1) = sLeave(izone)
c                                       tEnter(izone+1) = tLeave(izone)
c
c                                       Compute the desired parameters
c                                       for the zone we just left.
c                                       npar according to the velocity table 15Jan93

        npar(izone,iray)    = accum(4)
        ivind(izone,iray) = ivtabl(npar(izone, iray))
        npar(izone,iray)    = 1./vpar(ivind(izone,iray))
        izind(izone,iray) = IzindOld

        ezsq(izone,iray)    = accum(1) *
     ^                        (tLeave(izone)-tEnter(izone)) / omega /
     ^                         dVol(IzindOld)
        dlnPdsK(izone,iray) = accum(2) * cEparik /
     ^                        (npar(izone,iray) * woc)**2 *
     ^                        (tLeave(izone)-tEnter(izone)) 
        dlnPdsX(izone,iray) = accum(3) *
     ^                        (tLeave(izone)-tEnter(izone)) 
 

        if (ezsq(izone,iray) .lt. 0.) then
          write(ErrMsg,'('' Ez2<0!zn ind iry epsL epsZ:''
     ^    , i4,i4,i3,1pe10.2,1x,1pe10.2)')
     ^    izone, IzindNew, iray, epsL, epsZ
          call LSCwarn( ErrMsg)
          ezsq(izone,iray)   = 0.0
          dlnPdsK(izone,iray)= 0.0
          dlnPdsX(izone,iray)= 0.0
        endif
        dtdV                = (tLeave(izone)-tEnter(izone)) /
     ^                        ( abs(dVol(izindOld)) + SMALL )
c                                       Dont forget to save the integers.

 
c                                       We are done with the information
c                                       accumulated for the old zone, so
c                                       set the accumulator to the value
c                                       of the parameters we just calc-
c                                       ulated.  Reset counter.
        do 102 i=1,nRayQt
          accum(i)=RayQt(i)
 102    continue
          NinAc = 1
 
c                                       If we have more zones to go, then
C                                       INCREMENT THE ZONE COUNTER, and
c                                       fill the arrays with the same
c                                       values we just found, in case
c                                       we run out of time steps (eg).
        if (izone .lt. nzones) then
          izone = izone + 1
          RofRay(izone)        = RofRay(izone-1)
          ZofRay(izone)        = ZofRay(izone-1)  
          PofRay(izone)        = PofRay(izone-1)  
          NparRy(izone)        = NparRy(izone-1)
          NperRy(izone)        = NperRy(izone-1)
          rtPsRy(izone)        = rtPsRy(izone-1)
          NeofRy(izone)        = NeofRy(izone-1)
          BthRay(izone)        = BthRay(izone-1)
          BphRay(izone)        = BphRay(izone-1)

          ezsq   (izone,iray)  = ezsq   (izone-1,iray)
          dlnPdsK(izone,iray)  = dlnPdsK(izone-1,iray)
          dlnPdsX(izone,iray)  = dlnPdsX(izone-1,iray)
          npar   (izone,iray)  = npar   (izone-1,iray)
          ivind  (izone,iray)  = ivind  (izone-1,iray)
          dum = 1.+dlnPdsX(izone-1,iray)
          dum = amax1(MxdPdZ,dum)
          dum = amin1(dum,ONE)

          PowrRy (izone)       = PowrRy(izone-1)*dum
          izind  (izone,iray)  = IzindNew
        else
c                                       But, if we used up all the zones,
c                                       quit as fast as you can.
          izone = nzones
          Lstop = 1
        endif
c
c     .                                 If Npar is so large that damping would
c     .                                 be total, stop the calculation now.
        if ( abs(npar(izone,iray)) .gt. NparDead ) then
          Lstop = 1
        endif
c     .                                 If Nper is really large, stop now.
c     .                                 No matter what.
          if ( abs(nperRy(izone))    .gt. NperDead ) then
            Lstop = 1
          endif
c     .
c     .                                 If all power is gone in Maxwellian
c     .                                 stop the calculation now.  
          if ( PowrRy(izone) .lt. MaxwDead ) then
            Lstop = 1
            if (PrFlg(RAYWR) .ge. TRUE) then
              write(nLSCcomm,'('' Maxwellian power=0; stop early'')')
            endif
          endif
      endif
c                                       END   major IF/ELSE/ENDIF branch.
 
c
c                                       See if we jumped more than
c                                       one zone.  Report if so.
      IzindJmp = IzindNew - IzindOld
      if (IzindJmp*IzindJmp .gt. 1) then
         if (PrFlg(RAYWR) .ge. TRUE ) then
            write(nLSCcomm,'('' Jumped more than one zone;'',
     ^           '' izone, IzindNew, jump = '',
     ^             i4, 1x, i4, 1x, i4)')izone, IzindNew, IzindJmp
c                                       If we jumped more than one zone
c                                       and the ray is well advanced, then
c                                       there is probably trouble coming.
         endif
        if(izone .ge. nzones/10) then
         call LSCwarn( ' More than 1 zone jumped and izone >> 1 ')
        endif
      endif
c                                       Set the  _Old parameters to the
c                                       existing _New ones.  
      sOld  = sNew
      tOld  = tNew
      IzindOld = IzindNew
      RzindOld = RzindNew
c
      return
      END
c
c                                                                      |
c     E2byPr ends                           ---------------------------|
c
      SUBROUTINE RyZnInit
#include "Implic.inc"
#include "params.inc"
#include "RayBins.inc"
#include "RayWrk.inc"
      INTEGER i,j
c
c     Initialize  ray zones                     -----------------------|
c                                                                      |

c
c                                       `Zero' arrays.
      j = iray
                do 10 i=1,NZONDIM
                    RofRay (i) = Rmaj
                    ZofRay (i) = 0.0
                    PofRay (i) = 0.0
                    NperRy (i) = 1.0
                    rtPsRy (i) = 1.0
                    PowrRy (i) = 1.0
                    TimeRy (i) = 0.0
                    DistRy (i) = 0.0
                    DetrRy (i) = 0.0
c               do 10 j=1,NRAYDIM     !! 9sep 93
                    ezsq (i,j) = 1.0
                  dlnPds (i,j) = 0.0
                  dlnPdsK(i,j) = 0.0
                  dlnPdsX(i,j) = 0.0
c                                      For izind, ivind the value 0 has
c                                      no meaning -- its an incorrect address.
c                                      This is used as a flag that this ray bin
c                                      was not filled in the calculation.
                    izind(i,j) = 0
                    ivind(i,j) = 0
 10             continue
c                                       But do npar separately since the
c                                       first zone location is filled with
c                                       information from launched spectrum.
                do 20 i=2,nzones
c               do 20 j=1,nrays      !! 9sep 93
                    npar (i,j) = 1.0
 20             continue
      
      return
      END

c                                                                      |
c     Finished Initializing ray zones                ------------------|
c
c                                                                      |
c                                                                      |
c     Raystore.F                        -------------------------------|
