      SUBROUTINE grapLSC(imode, xx, zz, psval, psderiv, isw, 
     ^     xmin, deex, zmin, deez, isave, jsave, nx, nz, nxdim,
     ^     psi, fmat)
c***************************************************************
c     *
c     GRid APproximation in the Lower hybrid Simulation Code
c     local bivariate interpolation*
c     *
c***************************************************************
c     
c     imode=0   returns everything
c     =1   returns psval only
c.....
c     
c     isw=1 forces recalculation of coefficient matrix
c     =0 may not recalculate coefficient matrix if same
c     i,j as last call
c     
#include "Implic.inc"
      INTEGER imode, isw, jval, ival, m, k, l, ii, i, j, nx, nz, 
     ^     iplus, iminus, jplus, jminus, isave, jsave, frstcall, nxdim
      INTEGER LLC, LRC, ULC, URC, LEFT,
     ^     RIGHT, TOP, BOTTOM, INTERIOR, FALSE, TRUE
      PARAMETER(
     ^     FALSE = 0, TRUE = 1,  INTERIOR = 1, 
     ^     LLC = 5,  LRC = 6,    ULC = 7,   URC = 8,
     ^     LEFT = 9, RIGHT = 10, TOP = 11,  BOTTOM = 12)
      REAL 
     ^     zz, xx, gradsq, dpsidx, dpsidz, psval, psixz,
     ^     psixx, psizz, psi, deez, deex, zmin, 
     ^     xmin, rival, rjval, cx, cy, psderiv
      REAL 
     ^     vmat, fmat, poly, xpa, zpa, rhs1, rhs2, rhs3, rhs4, sum1,
     ^     sum2, sum3, sum4, sum5, sum6, xp, zp, ff, f1
      DATA frstcall / TRUE / 
      DIMENSION vmat(4,4),fmat(0:3,0:*),poly(0:3,0:3)
      DIMENSION xpa(0:3),zpa(0:3)
      DIMENSION psi(nxdim, nz), psderiv(0:2, 0:*)
      DATA xpa(0),zpa(0)/ 1., 1./
c     
      rjval = (zz-zmin)/deez+1.
      rival = (xx-xmin )/deex+1.
      jval = rjval
      ival = rival
c     
      if(ival .lt. 2)then
         ival = 2
      else if(ival. gt. nx - 2)then
         ival = nx - 2
      endif
      if(jval .lt. 2)then
         jval = 2
      else if(jval. gt. nz - 2)then
         jval = nz - 2
      endif
      if( (frstcall .eq. FALSE) .and.
     ^     (ival.eq.isave .and. jval.eq.jsave .and. isw.eq.0) )then
         go to 200
      endif
      frstcall = FALSE
      isave = ival
      jsave = jval
c     
c     begin INTERIOR point
      do 10 ii=1,4
         go to(101,102,103,104),ii
 101     i      = ival
         j      = jval
         iplus = i + 1
         jplus = j + 1
         iminus = i - 1
         jminus = j - 1
         cx = 0.50
         cy = 0.50
         go to 105
 102     i      = ival
         j      = jval+1
         iplus = i + 1
         jplus = j + 1
         iminus = i - 1
         jminus = j - 1
         cx = 0.50
         cy = 0.50
         go to 105
 103     i      = ival+1
         j      = jval
         iplus = i + 1
         jplus = j + 1
         iminus = i - 1
         jminus = j - 1
         cx = 0.50
         cy = 0.50
         go to 105
 104     i      = ival+1
         j      = jval+1
         iplus = i + 1
         jplus = j + 1
         iminus = i - 1
         jminus = j - 1
         cx = 0.50
         cy = 0.50
 105     continue
c     
c...psi:
c     
         vmat(1, ii) =      psi(i, j)     - psi(ival, jval)
         vmat(2, ii) = cx * (psi(iplus, j  ) - psi(iminus, j) )
         vmat(3, ii) = cy * (psi(i, jplus) - psi(i, jminus)  )
         vmat(4, ii) = cx * cy * (psi(iplus, jplus) -
     ^        psi(iminus, jplus) - psi(iplus, jminus) +
     ^        psi(iminus, jminus) )
c     
 10   continue
c     end INTERIOR point
c     
c     
c..........................................................
c     
c     calculate function values and function derivatives
c     at four corners of the reference cell
c     
c..........................................................
c..........................................................c
c     determine coefficients by evaluating polynomial
c     at four corner points c
c..........................................................c
c...point(i,j):c
      fmat(0,0) = 0.
      fmat(1,0) = vmat(2,1)
      fmat(0,1) = vmat(3,1)
      fmat(1,1) = vmat(4,1)
c     
c...point(i,j+1):
c     
      fmat(0,2) = 3.*vmat(1,2) - 2.*fmat(0,1)
     .     -    vmat(3,2)
      fmat(0,3) =    vmat(3,2) +    fmat(0,1)
     .     - 2.*vmat(1,2)
      fmat(1,2) = 3.*vmat(2,2) - 3.*fmat(1,0)
     .     -    vmat(4,2) - 2.*fmat(1,1)
      fmat(1,3) =    vmat(4,2) + 2.*fmat(1,0)
     .     - 2.*vmat(2,2) +    fmat(1,1)
c     
c...point(i+1,j):
c     
      fmat(2,0) = 3.*vmat(1,3) - 2.*fmat(1,0)
     .     -    vmat(2,3)
      fmat(3,0) =    vmat(2,3) +    fmat(1,0)
     .     - 2.*vmat(1,3)
      fmat(2,1) = 3.*vmat(3,3) - 3.*fmat(0,1)
     .     -    vmat(4,3) - 2.*fmat(1,1)
      fmat(3,1) =    vmat(4,3) + 2.*fmat(0,1)
     .     - 2.*vmat(3,3) +    fmat(1,1)
c     
c...point(i+1,j+1):
c     
      rhs1=   vmat(1,4)-vmat(1,3)-vmat(3,3)
     .     -  (fmat(0,2)+fmat(1,2)
     .     +   fmat(0,3)+fmat(1,3) )
      rhs2=   vmat(2,4)-vmat(2,3)-vmat(4,3)
     .     -  (fmat(1,2)+fmat(1,3) )
      rhs3=   vmat(3,4)-vmat(3,3)
     .     -2*(fmat(0,2)+fmat(1,2) )
     .     -3*(fmat(0,3)+fmat(1,3) )
      rhs4=   vmat(4,4)-vmat(4,3)
     .     -2*(fmat(1,2) )
     .     -3*(fmat(1,3) )
c     
      fmat(2,2) =  9*rhs1-3*rhs2-3*rhs3+rhs4
      fmat(3,2) = -6*rhs1+3*rhs2+2*rhs3-rhs4
      fmat(2,3) = -6*rhs1+2*rhs2+3*rhs3-rhs4
      fmat(3,3) =  4*rhs1-2*rhs2-2*rhs3+rhs4
 200  continue
c...........................................................
c     
c     evaluate function and derivatives at (xx,zz)
c     
c...........................................................
c      if(rival .le. 1.)then
c         rival = 1.
c      else if(rival .gt. float(nx))then
c         rival = float(nx)
c      endif
c      if(rjval .le. 1.)then
c         rjval = 1.
c      else if(rjval .gt. float(nz))then
c         rjval = float(nz)
c      endif
      xp     = rival - ival
      zp     = rjval - jval
c     
c     begin evaluate function
      do 32 m=1,3
         xpa(m) = xp*xpa(m-1)
 32      zpa(m) = zp*zpa(m-1)
         do 33 l=0,3
            do 33 k=0,3
 33            poly(k,l) = xpa(k)*zpa(l)
c     
c     
               sum1   = 0.
               do 40 k = 0,3
                  do 45 l = 0,3
                     f1     = fmat(k,l)
                     sum1   = sum1 + f1*poly(k,l)
 45               continue
 40            continue
               psval  = sum1 + psi(ival,jval)
c     end evaluate function
c     
               if(imode.eq.1) then
                  do 47 k = 0, 2
                     do 48 l = 0, 2
                        psderiv(k, l) = 0.
 48                  continue
 47               continue
c     
                  return
c     
               endif
c     
c     begin evaluate derivatives
               sum2   = 0.
               do 55 l = 0,3
                  do 50 k = 0,2
                     ff     = (k+1)*fmat(k+1,l)
                     sum2   = sum2 + ff*poly(k,l)
 50               continue
 55            continue
               dpsidx = sum2/deex
c     
               sum3   = 0.
               do 75 k = 0,3
                  do 70 l = 0,2
                     ff     = (l+1)*fmat(k,l+1)
                     sum3   = sum3 + ff*poly(k,l)
 70               continue
 75            continue
               dpsidz = sum3/deez
               gradsq = dpsidx**2 + dpsidz**2
c     
               sum5   = 0.
               do 65 l = 0,3
                  do 60 k = 0,1
                     ff     = (k+1)*(k+2)*fmat(k+2,l)
                     sum5   = sum5 + ff*poly(k,l)
 60               continue
 65            continue
               psixx  = sum5/deex/deex
c     
c     
c     
               sum6   = 0.
               do 85 k = 0,3
                  do 80 l = 0,1
                     ff     = (l+1)*(l+2)*fmat(k,l+2)
                     sum6   = sum6 + ff*poly(k,l)
 80               continue
 85            continue
               psizz  = sum6/deez/deez
c     
c     
               sum4   = 0.
               do 90 k = 0,2
                  do 95 l = 0,2
                     ff     = (k+1)*(l+1)*fmat(k+1,l+1)
                     sum4   = sum4 + ff*poly(k,l)
 95               continue
 90            continue
               psixz  = sum4/deex/deez
c     end evaluate derivatives
c     
c     
c     
               psderiv(0, 0) = gradsq
               psderiv(1, 0) = dpsidx
               psderiv(2, 0) = psixx
               psderiv(0, 1) = dpsidz
               psderiv(0, 2) = psizz
               psderiv(1, 1) = psixz
               return
               END
c
c     ------------------------------------------------------------------
c
      SUBROUTINE grrg1d(nx, xmin, dx, ydata, jold, xx, yy, ypr, coef)
#include "Implic.inc"
#include "tscunits.inc"
      INTEGER FORCE_CALCULATION
      PARAMETER(FORCE_CALCULATION = -1)
      INTEGER nx, jold, j
      REAL    
     ^        xmin, dx, ydata(nx), xx, yy, ypr, coef(*), rj, 
     ^        left1, left2, xrel, ydpr
c     GRid, ReGulalr, interpolation in 1D
c     cubic interpolation yint(x) for points 1, 2, 3, 4 set by conditions
c     yint(2) = ydata(2)
c     yint(3) = ydata(3)
c     d yint(2) / dx = (ydata(3) - ydata(1)) / (2 * dx)
c     d yint(3) / dx = (ydata(4) - ydata(2)) / (2 * dx)
c     
c     here: yint = sum(1 - 4) * coef(j) * ((x - x(2)) ** (j - 1))
      rj = (xx - xmin) / dx + 1.
      j = aint(rj)
      if(j .lt. 1) then
        yy = ydata(1)
        ypr= 0.
           write(nLSCcom2, '( '' x out of range LOW  in grrg1d: '' )')
        return
      endif
      if(j .gt. (nx - 1))then
        yy = ydata(nx)
        ypr= 0.
           write(nLSCcom2, '( '' x out of range HIGH in grrg1d: '' )')
        return
      endif

      if((jold .eq. FORCE_CALCULATION) .or. (j .ne. jold))then
c     compute new coefficients
         if((j .gt. 1) .and. (j .lt. (nx - 1)))then
            coef(1) = ydata(j)
            coef(2) = 0.5 * (ydata(j + 1) - ydata(j - 1))
            left1 = (ydata(j + 1) - (coef(1) + coef(2)))
            left2 = (0.5 * (ydata(j + 2) - ydata(j))- coef(2))
            coef(3) = -left2 + 3. * left1
            coef(4) = (left2 - 2. * left1)
         else if(j .eq. 1)then
            coef(1) = ydata(1)
            ydpr = 0.5 * (ydata(3) - ydata(1))
            coef(3) = ydpr - (ydata(2) - ydata(1))
            coef(2) = ydpr - 2. * coef(3)
            coef(4) = 0.
         else if(j .eq. (nx - 1) )then
            coef(1) = ydata(nx - 1)
            coef(2) = 0.5 * (ydata(nx) - ydata(nx - 2))
            coef(3) = (ydata(nx) - coef(1) - coef(2))
            coef(4) = 0.
         endif
      endif
c     compute yy, ypr
      xrel = rj - j
      yy = ((coef(4) * xrel + coef(3)) * xrel + coef(2)) * xrel
     ^     + coef(1)
      ypr = ((3. * coef(4) * xrel + 2. * coef(3)) * xrel + coef(2)) /
     ^     dx
      return
      END
c
c     ------------------------------------------------------------------
c
      SUBROUTINE grnu1d(nx, xdata, ydata, jold, coef, x, y, yp )
#include "Implic.inc"
#include "params.inc"
#include "PlPr.inc"
#include "tscunits.inc"
      INTEGER j, jold, jguess, nx
      INTEGER FORCE_CALCULATION
      PARAMETER(FORCE_CALCULATION = -1)
      REAL    xdata(nx), ydata(nx), x, y, yp, coef(4)
      REAL    x21,      x32
      REAL    d21, d31, d32, d42, dx
c     GRid, NonUniform, interpolation in 1D
c     cubic interpolation yint(x) for points 1, 2, 3, 4 set by conditions
c     yint(2) = ydata(2)
c     yint(3) = ydata(3)
c     d yint(2) / dx = (ydata(3) - ydata(1)) / (xdata(3) - xdata(1) )
c     d yint(3) / dx = (ydata(4) - ydata(2)) / (xdata(4) - xdata(2) )
c
c     here: yint = sum(1 - 4) * coef(j) * ((x - x(2)) ** (j - 1))
c
c                                       find which interval we are in by
c                                       Numerical Recipes HUNT routine
      jguess = jold
      call huntnr(xdata, nx, x, jguess)
      j = jguess
      
      if (j .eq. 0 ) then
        y  = ydata(1)
        yp = 0.
        return
      endif
      if ( j. eq. nx) then
        y  = ydata(nx)
        yp = 0.
        return
      endif

      if((jold .eq. FORCE_CALCULATION) .or. (j .ne. jold))then
c     compute new coefficients
        jold = j
        if((j .gt. 1) .and. (j .lt. (nx - 1))) then
            x32     = (xdata(j + 1) - xdata(j    ))
            d31     = (ydata(j + 1) - ydata(j - 1)) /
     ^                (xdata(j + 1) - xdata(j - 1))
            d32     = (ydata(j + 1) - ydata(j    )) /
     ^                (xdata(j + 1) - xdata(j    ))
            d42     = (ydata(j + 2) - ydata(j    )) /
     ^                (xdata(j + 2) - xdata(j    ))
 
            coef(1) = ydata(j)
            coef(2) = d31
            coef(3) = (3.*(d32 - d31) -    (d42 - d31) ) /  x32
            coef(4) = (   (d42 - d31) - 2.*(d32 - d31) ) / (x32*x32)
         else if(j .eq. 1)then
            x21     = (xdata(2    ) - xdata(    1))
            d21     = (ydata(2    ) - ydata(    1)) /
     ^                (xdata(2    ) - xdata(    1))
            d31     = (ydata(3    ) - ydata(    1)) /
     ^                (xdata(3    ) - xdata(    1))
            coef(1) = ydata(1)
            coef(2) = (2.*d21 - d31)
            coef(3) = (d31 - d21) / x21
            coef(4) = 0.

         else if(j .eq. (nx - 1) )then
            x32     = (xdata(nx   ) - xdata(nx- 1))
            d31     = (ydata(nx   ) - ydata(nx- 2)) /
     ^                (xdata(nx   ) - xdata(nx- 2))
            d32     = (ydata(nx   ) - ydata(nx- 1)) /
     ^                (xdata(nx   ) - xdata(nx- 1))
            coef(1) = ydata(nx - 1)
            coef(2) =  d31
            coef(3) = (d32 - d31) / x32
            coef(4) = 0.
         endif
      endif
c     compute y, yp
      dx = x - xdata(j)
      y  = ((coef(4) * dx + coef(3)) * dx + coef(2)) * dx
     ^     + coef(1)
      yp = ((3. * coef(4) * dx + 2. * coef(3)) * dx + coef(2))
      return
      END
c
c     ------------------------------------------------------------------
c
      SUBROUTINE linr1d(nx, xdata, ydata, x, y )
#include "Implic.inc"
      INTEGER j, jguess, nx
      REAL    xdata(nx), ydata(nx), x, y, coef(2)
      REAL    d21, dx
c     LINeaR interpolation in 1D
c
c     Try to look much like grnu1d, which see above.
c     The derivative is guaranteed not continuous.  
c     Given to make consistent with grnu1d.
c     Linear interpolation of interest to avoid fake oscillations
c     in the interpolant.
c
c     here: yint = sum(1 - 2) * coef(j) * ((x - x(1)) ** (j - 1))
c
c                                       find which interval we are in by
c                                       Numerical Recipes HUNT routine
      jguess = -1
      call huntnr(xdata, nx, x, jguess)
      j = jguess
      
      if (j .eq. 0 ) then
        y  = ydata(1)
c       yp = 0.                         yp not of interest since its not
c                                       continuous.
        return
      endif
      if ( j. eq. nx) then
        y  = ydata(nx)
c       yp = 0.                         yp not of interest
        return
      endif
c
c     This is the computation of the slope, and delta-x
            d21     = (ydata(j + 1) - ydata(j    )) /
     ^                (xdata(j + 1) - xdata(j    ))
 
            coef(1) = ydata(j)
            coef(2) = d21
            dx = x - xdata(j)
c
      y  = coef(2) * dx + coef(1)
c     yp = coef(2)                      yp not of interest

      return
      END
c
c     ------------------------------------------------------------------
c
      SUBROUTINE huntnr( xx, n, x, jlo )
c     Given an array XX  of length  N , and given a value  X , returns
c     a value  JLO  such that  x  is between  XX(jlo)  and XX(jlo+1).
c     XX  must be monotonic, either increasing or decreasing.
c     JLO=0 or =N is returned to indicate that  X  is out of range.
c     JLO on input is taken as a the initial guess for  JLO on output.
c     Ref:  Numerical Recipes in Fortran, p 91.
#include "Implic.inc"
      INTEGER inc, jlo, jhi, jm, n
      REAL    xx(n), x
      LOGICAL ascnd
c
c                                       True if table in ascending order.
      ascnd =  xx(n) .gt. xx(1) 
c                                       If input guess is not useful, then
c                                       go immediately to bisection.
      if ( jlo .le. 0 .or. jlo .gt. n ) then
        jlo = 0
        jhi = n + 1
        go to 3
      endif
 
c                                       Set the hunting increment.
      inc = 1
c                                       Hunt up.
      if ( x .ge. xx(jlo)  .eqv.  ascnd ) then
 1      jhi = jlo + inc
c                                       Done hunting; off the table.
        if ( jhi .gt. n ) then
            jhi = n + 1
c                                       Not done hunting.
        else if ( x .ge. xx(jhi)  .eqv.  ascnd ) then
            jlo = jhi
c                                       Double increment, try again.
            inc = inc + inc
            go to 1
c                                       Done hunting, value bracketed.
        endif
c                                       Hunt down.
      else
        jhi = jlo
 2      jlo = jhi - inc
c                                       Done hunting; off the table.
        if ( jlo .lt. 1 ) then
            jlo = 0
c                                       Not done hunting.
        else if ( x .lt. xx(jlo)  .eqv.  ascnd ) then
            jhi = jlo
c                                       So double increment, try again.
            inc = inc + inc
            go to 2
c                                       Done hunting, value bracketed.
        endif
      endif
c                                       Begin bisection phase.
 3    if ( jhi - jlo .eq. 1 ) return
      jm = (jhi + jlo) / 2
      if ( x .gt. xx(jm) .eqv. ascnd ) then
        jlo = jm
      else
        jhi = jm
      endif
      go to 3
      END
c
c     ------------------------------------------------------------------
c
