c     PlasEJV   begins                      ---------------------------|
c                                                                      |
c                                                                      |
      SUBROUTINE ProfInit
#include "Implic.inc"
#include "params.inc"
#include "RayBins.inc"
#include "ProfBody.inc"
#include "TSCgrap.inc"
      INTEGER
     ^        ip
      do 10 ip = 1, npsi
         call GePlPar(PsiAry(ip), NeAry(ip), TeAry(ip), ZbrAry(ip),
     ^                LnlAry(ip), BetZAry(ip))
c                                       get plasma parameters
c                                       given PsiAry, returns :
c                                       TeAry   electron temperature in Kev
c                                       NeAry   electron density in cm^-3
c                                       ZbrAry  Z bar for e-i collison rate
c                                       LnlAry  Coulombic logarithm
c                                       BetZAry Beta value of Eder & Valeo 
c                                       Lnl BetZ added by D. P. Enright

 10   continue
      return
      END

      SUBROUTINE GePlPar(psi, Negl, Tegl, Zbrgl, Lnlgl, BetZgl)
c                                       get plasma parameters
#include "Implic.inc"
#include "params.inc"
#include "ProfBody.inc"
#include "TSCgrap.inc"
      REAL
     ^        psi, RBphi,      pe2, pi2,
     ^        aio, ael, Negl, Tegl, Zbrgl, Lnlgl, BetZgl,  psiold 
      DATA psiold / -100. /
      call plasma1d (psi, psiold, RBphi, Tegl, pe2, pi2, aio, ael)
      Negl = 1.e14 * pe2 / pe2Fac
      Zbrgl = pe2 / pi2 * (pi2Fac / pe2Fac)
      if (Tegl .le. .01) then
         Lnlgl = 23. - log(sqrt(Negl) * 1./(Tegl * sqrt(Tegl) * 
     ^                                     1000.**(3./2.)))
      else
         Lnlgl = 24. - log(sqrt(Negl) * 1./(Tegl * 1000.))
      endif   
      BetZgl = (1. + Zbrgl)/5.
      return
      END
c                                                                      |
c                                                                      |
c     PlasEJV   ends                        ---------------------------|

